﻿Type=Service
Version=6.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
	'#######################################################################################################
	' SQL1
	'Tabela:Pizza   Campos	: id, sabor, detalhe, precop, preco, precog, stk
	'		Refri			: id, sabor, detalhe, preco, OkMenu, Stk, StkMin, Obs  
	'		Extras			: id, sabor, detalhe, preco, OkMenu, Stk, StkMin, Obs
	'#######################################################################################################
	' SQL2 
	'Tabela: Pedidos    Campos: id, idnuvem, nome, cel, CodCli, Data, entregue, valor, pago, codformapgto, codformaentrega, 
	'		 					pedidostr, origem, msg, Bxdo

	'        TempPed   Campos:  id, TabOrig, CodItem, sabor, detalhe, Qtd, Preco, Desconto, VlrTotItem, bxdoi, ordem, 
	'							idpedidos
	'#######################################################################################################
   	' SQL3 
	'
	'Tabela: Pizza   Campos	: id, sabor, detalhe, precop, preco, precog, stk
	'		 Refri			: id, sabor, detalhe, preco, OkMenu, Stk, StkMin, Obs  
	'		 Extras			: id, sabor, detalhe, preco, OkMenu, Stk, StkMin, Obs
	'Tabela: Pedidos  Campos: id, idnuvem, nome, cel, CodCli, Data, entregue, valor, pago, codformapgto, codformaentrega, 
	'		 pedidostr, origem, msg, Bxdo
	'
	'										            vieram via pedidostr		
	'									          |______________________________|	
	'Tabela: Logis    Campos: id, idbase, idnuvem, idpedcli, taborig, coditem, qtd, bxdo, codcli, codentregador
	'                            	|	             |
	'								|		         |>é o id da tempped do cliente, que veio no pedidostr
	'							    |
	'								|>é o id na Tab: Pedidos.id do SQL3
	

    ' B4A  FORUM
	'Please use [code]code here...[/code] tags when posting code.
  
   
   '     SUBDIR
		'With DirRootExternal you can also add a subdirectory.
		'For example: DirRootExternal & "/MyDatabase"
		'Don't forget to create the subdirectory : File.MakeDir(File.DirRootExternal, "MyDatabase")           
            
    

	        

#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	
	Public kvs As KeyValueStore
	
	
	
	Public clicode, codformapgto, codformaentrega, idpedidos, idnuvem, bxdo As Int
	Public linha(), linhaDB(), formapgto, subdir, clinome, clicel, cliend, pedidostr, entregue, origem, msg As String
	Public SQL1, SQL2, SQL3 As SQL
	Public Online As Boolean
	Public pedido, ttmap As Map	
	Public DirX As String	
	Public TotalPed, pago As Double	
	'  DiaHora=Ano&Mes&Dia&Hora&Minuto
	Public DiaHora As String  			'SC		Ano&Mes&Dia&Hora&Minuto
	Public Adm As String
	
	'===============================================================================================
	Public WebTab As Map  'Map que operacionaliza o WebView1_OverrideUrl()
	' Variaveis na WebTab.put("XXX", Var)  "XXX"=  col, row, sql, query, fxx (xx=campo Nr.), fqty    
	
	'===============================================================================================
	
	Public bxdotxt As Map
	'Public PedAberto As Int    'PedAberto é o elo de ligação entre cli e nuvem
	
	'===============================================================================================

	Public ProxPedNr As Int 'É o número que esta sobre a mesa sendo preenchido e vai entrar como 
	'						 id dos pedidos
	'===============================================================================================

	Public WebViewPlace As String


End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
		
	
	'================================================================================================================
	
	
	Adm=1 'É administrador
	
	'================================================================================================================
		
	WebTab.initialize
	WebTab.Put("col",-1)	
		
	'================================================================================================================
		
	idpedidos=0	
	bxdo=0
	
	'================================================================================================================
	
	If  Connected=False Then
		ToastMessageShow("17 - Sem conexão.",False)
		Online=False
	Else
		ToastMessageShow("18 - Existe conexão.",False)
		Online=True
	End If

	'================================================================================================================
	
	subdir = "DigiBob"
	DirX=File.DirRootExternal & "/" & subdir

	Try
		File.MakeDir(File.DirRootExternal, subdir)
	Catch
		Log(LastException)
	End Try

	'--------------------------------------------- GRUPO do SQL1 ----------------------------------------------------
	
	SQL1.Initialize(DirX ,"Menu"&".db", True)	'.................. SQL1 dos Dados Basicos no NEGÓCIO	
	
	Try
		'Tabela:Pizza   Campos:id, sabor, detalhe, precop, preco, precog, stk
		SQL1.ExecNonQuery("CREATE TABLE IF NOT EXISTS pizza(id INTEGER PRIMARY KEY, sabor TEXT, detalhe TEXT, precop DOUBLE, preco DOUBLE, precog DOUBLE, stk INTEGER)")
	Catch
		Log(LastException)
	End Try
	Try
		'Refri: id, sabor,detalhe, preco, OkMenu, Stk, StkMin, Obs
		SQL1.ExecNonQuery("CREATE TABLE IF NOT EXISTS refri(id INTEGER PRIMARY KEY, sabor TEXT, detalhe TEXT, preco DOUBLE, OkMenu INTEGER, stk DOUBLE, stkmin DOUBLE, obs TEXT)")
	Catch
		Log(LastException)
	End Try
	Try
		'Extras: id, sabor,detalhe, preco, OkMenu, Stk, StkMin, Obs
		SQL1.ExecNonQuery("CREATE TABLE IF NOT EXISTS extras(id INTEGER PRIMARY KEY, sabor TEXT, detalhe TEXT, preco DOUBLE, OkMenu INTEGER, stk DOUBLE, stkmin DOUBLE, obs TEXT)")
	Catch
		Log(LastException)
	End Try
	
	'--------------------------------------------- GRUPO do SQL2 ----------------------------------------------------
		
	SQL2.Initialize(DirX ,"Order"&".db", True) 	'.................. SQL2 dos dados do CLIENTE

	Try 
		SQL2.ExecNonQuery("CREATE TABLE IF NOT EXISTS pedidos(id INTEGER PRIMARY KEY, idnuvem INTEGER, nome TEXT, cel TEXT, CodCli INTEGER, Data TEXT, entregue TEXT, valor DOUBLE, pago DOUBLE, codformapgto INTEGER, codformaentrega INTEGER, pedidostr TEXT, origem TEXT, msg TEXT, Bxdo INTEGER)")
		
	Catch
		Log(LastException)
	End Try
	'TempPed   Campos:  id, TabOrig, CodItem, sabor, detalhe, Qtd, Preco, Desconto, VlrTotItem, bxdoi, ordem

	Try
		'DBUtils.DropTable(SQL2,"tempped")
		SQL2.ExecNonQuery("CREATE TABLE IF NOT EXISTS tempped(id INTEGER PRIMARY KEY, taborig TEXT, coditem INTEGER, sabor TEXT, detalhe TEXT, qtd DOUBLE, preco DOUBLE, desconto DOUBLE, vlrtotitem DOUBLE, bxdoi INTEGER, ordem INTEGER, idpedidos INTEGER )")
	Catch
		Log(LastException)
	End Try
	
	'--------------------------------------------- GRUPO do SQL3 ----------------------------------------------------

	If Adm=1 Then
		SQL3.initialize(DirX ,"Adm"&".db", True)	'...... SQL3 dos daos para gestão do negócio pelo ADM
		SQL3.ExecNonQuery("CREATE TABLE IF NOT EXISTS pizza(id INTEGER PRIMARY KEY, sabor TEXT, detalhe TEXT, precop DOUBLE, preco DOUBLE, precog DOUBLE, stk INTEGER)")
		SQL3.ExecNonQuery("CREATE TABLE IF NOT EXISTS refri(id INTEGER PRIMARY KEY, sabor TEXT, detalhe TEXT, preco DOUBLE, OkMenu INTEGER, stk DOUBLE, stkmin DOUBLE, obs TEXT)")
		SQL3.ExecNonQuery("CREATE TABLE IF NOT EXISTS extras(id INTEGER PRIMARY KEY, sabor TEXT, detalhe TEXT, preco DOUBLE, OkMenu INTEGER, stk DOUBLE, stkmin DOUBLE, obs TEXT)")
		SQL3.ExecNonQuery("CREATE TABLE IF NOT EXISTS pedidos(id INTEGER PRIMARY KEY, idnuvem INTEGER, nome TEXT, cel TEXT, CodCli INTEGER, Data TEXT, entregue TEXT, valor DOUBLE, pago DOUBLE, codformapgto INTEGER, codformaentrega INTEGER, pedidostr TEXT, origem TEXT, msg TEXT, bxdo INTEGER)")
		SQL3.ExecNonQuery("CREATE TABLE IF NOT EXISTS logis(id INTEGER PRIMARY KEY, idbase INTEGER,idnuvem INTEGER, idpedcli INTEGER, taborig TEXT, coditem INTEGER, qtd DOUBLE, bxdo INTEGER, CodCli INTEGER, codentregador INTEGER)") 
	End If
	'================================================================================================================
	
	ttmap.initialize
	
	If File.Exists(DirX, "TT.txt") Then
		
		ttmap=File.ReadMap( DirX,"TT.txt")
		
		Try
			clinome=ttmap.Get("clinome")
			clicel =ttmap.Get("clicel") 
			clicode =ttmap.Get("clicode") 
			cliend=ttmap.Get("cliend")
			idpedidos=ttmap.Get("idpedidos")
		Catch
			Log(LastException)
			clinome="":ttmap.Put("clinome",clinome)
			clicel="":ttmap.Put("clicel",clicel)
			clicode=-1:ttmap.Put("clicode",clicode)
			cliend="":ttmap.Put("cliend",cliend)
			idpedidos=0:ttmap.put("idpedidos",0)
			File.WriteMap(DirX,"TT.txt",ttmap)
		End Try
	Else
		clinome="":ttmap.Put("clinome",clinome)
		clicel="":ttmap.Put("clicel",clicel)
		clicode=-1:ttmap.Put("clicode",clicode)
		cliend="":ttmap.Put("cliend",cliend)
		idpedidos=0:ttmap.put("idpedidos", idpedidos)
		File.WriteMap(DirX,"TT.txt",ttmap)
	End If
	
	'================================================================================================================
	
	bxdotxt.Initialize				'É a descrição do processo via bxdo, rastreabilidade do processo
	
	Dim DummyCli As String

	If clinome<>"" Then
		DummyCli=clinome
		Else
		DummyCli="Cliente "
	End If
	bxdotxt.put(0,DummyCli & " escolhendo.")
	bxdotxt.put(5,DummyCli & " enviou pedido.")
	bxdotxt.put(10,"Confirmamos pedido")
	bxdotxt.put(20,"No Pizzaiolo")
	bxdotxt.put(30,"P separar no Balcão")
	bxdotxt.put(35,"No Balcão")
	bxdotxt.put(40,"P separar para entrega")
	bxdotxt.put(45,"Com entregador")
	bxdotxt.put(50,"Entregue")
	bxdotxt.put(60,"Pago")
	'================================================================================================================

	Log("idpedidos = " & idpedidos)

	If idpedidos=0 Then 'Não tem  nenhum pedido em aberto....ou seja o anterior foi enviado 
							' foi zerado	
		
		If File.Exists (DirX, "Ped")  = False Then
			kvs.Initialize(DirX, "Ped")
    		Main.TpPed.id=idpedidos
			Main.TpPed.fentr=0
			Main.TpPed.fpgto=0
			kvs.Put("tpped",Main.TpPed)
			
		Else
			File.Delete (DirX, "Ped")
			kvs.Initialize(DirX, "Ped")
			Main.TpPed.id=idpedidos
			Main.TpPed.fentr=0
			Main.TpPed.fpgto=0
			kvs.Put("tpped",Main.TpPed)
			'get them
			Dim TpPedObj  As Object =  kvs.Get("tpped")  'the array type must be object or bytes
			Main.TpPed = TpPedObj 
		End If
	Else	
		ProxPedNr = ttmap.Get("idpedidos")
		kvs.Initialize(DirX, "Ped")
		'get them
		Dim TpPedObj  As Object =  kvs.Get("tpped")  'the array type must be object or bytes
		Main.TpPed = TpPedObj 
	End If
	
	
	
	Dim ct As TpItemT
	ct.id=0
	ct.Qtd=0
	ct.taborig="pizza"
	Main.TpPed(0).TpItem=ct
	
	Dim ct1  As TpItemT
	ct1.id=1
	ct1.Qtd=1
	ct1.taborig="refri"
	       
	Main.TpPed(0).TpItem = ct
	
	Log("Main.TpPed.id = " & Main.TpPed.id)
	Log("Main.TpPed.fentr = " & Main.TpPed.fentr)
	Log("Main.TpPed.fpgto = " & Main.TpPed.fpgto)
	
End Sub


Public Sub BuscaCliente
	'==============================================   Colega    ==================================
	'CallSubDelayed(EntraCel,"StartKolega")
	'=============================================================================================
End Sub


Sub GetResultColega(Result As Map)
	Log("GetResult no Starter->GetResultColega = " & Result)
	ttmap.Put("clinome",clinome)
	ttmap.Put("clicel",clicel)
	ttmap.Put("clicode",clicode)
	ttmap.Put("cliend",cliend)
	File.WriteMap(DirX,"TT.txt",ttmap)
	
	Log("####### Via GetResultColega(Result As Map)")
	
	CallSubDelayed(Main,"EnviaPedido")
	
End Sub



Sub Connected As Boolean
	Dim p1 As Phone
	Dim Response, Error As StringBuilder
	Response.Initialize
	Error.Initialize
	'Ping Google DNS - if you can't reach this -> net is not on
	Try
		p1.Shell("ping -c 1 8.8.8.8",Null, Response,Error)
	Catch
		ToastMessageShow("16 - " & LastException,True)
		Return False
	End Try
	
	If Error.ToString="" Then
		Return True
	Else
		'ToastMessageShow("Sem conexão.", False)
		Return False
	End If

End Sub



Sub Service_Start (StartingIntent As Intent)

End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
