﻿Type=Class
Version=6.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
Sub Class_Globals
	
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize

End Sub

' Atualiza na Tab:Pedidos (local)
Sub AtualizaPedido
	
	'##############################################################################################################
	'########################################   Monta a linha do pedido na Tab:Pedidos  ###########################
	'##############################################################################################################
	
	Starter.pedidostr = MontaPedidoStr
	
	If Starter.Pedidostr.Length>0 Then

		Dim ResList As List
			
		ResList= DBUtils.ExecuteList(Starter.SQL2, "SELECT id FROM pedidos WHERE id="& Starter.idpedidos ,Null,0)
		
		Starter.DiaHora  = DT.ano & DT.mes & DT.dia & DT.hora & DT.minuto

		Log("ResList.Size = " & ResList.Size)
			
		If ResList.Size>0 Then	'Já tem esta linha na Tab:pedidos
			
			Log("Editando a Tab:Pedidos ")
			Log(" com  Starter.idpedidos = " & Starter.idpedidos)
			
			Dim IdDoPedido As Int
			IdDoPedido=ResList.Get(0)
			Dim WhereFields As Map
			WhereFields.Initialize
			WhereFields.Put("id", IdDoPedido )
			
			DBUtils.UpdateRecord(Starter.SQL2, "pedidos" , "pedidostr", MontaPedidoStr, WhereFields)'
			DBUtils.UpdateRecord(Starter.SQL2, "pedidos" , "codformapgto", Starter.codformapgto, WhereFields)'
			DBUtils.UpdateRecord(Starter.SQL2, "pedidos" , "codformaentrega", Starter.codformaentrega, WhereFields)'
	
	
		Else 'Ainda NÃO tem esta linha na Tab:pedidos
			'Tabela: Pedidos    Campos: id, idnuvem, nome, cel, CodCli, Data, entregue, valor, pago, codformapgto,
			'							codformaentrega, pedidostr, origem, msg, Bxdo
			
			
			Starter.idpedidos = DB.LastID("id", "pedidos") + 1
			Log("Adicionando novo Item na tab: Pedidos")
			Log(" com  Starter.idpedidos = " & Starter.idpedidos)
			
			
			Dim ListOfMaps As List
			ListOfMaps.Initialize
			Dim insertmap As Map
			insertmap.Initialize
			insertmap.Put("id", Starter.idpedidos)     'Este é o Id do pedido, vai ser atribuido um novo
			insertmap.Put("idnuvem","")
			insertmap.Put("nome", Starter.clinome)
			insertmap.Put("cel",  Starter.clicel)
			insertmap.Put("codcli",Starter.clicode)
			insertmap.Put("data", Starter.DiaHora )
			insertmap.Put("entregue","0")
			insertmap.Put("valor", Starter.TotalPed)
			insertmap.Put("pago","0")
			insertmap.Put("codformapgto",Starter.codformapgto)
			insertmap.Put("codformaentrega",Starter.codformaentrega)
			insertmap.Put("pedidostr",MontaPedidoStr)
			insertmap.Put("origem","0")
			insertmap.Put("msg","msg")
			insertmap.Put("bxdo", "0" )
				
			ListOfMaps.Add(insertmap)
			DBUtils.InsertMaps(Starter.SQL2, "pedidos", ListOfMaps)
				
		End If
		
	Else
		ToastMessageShow("Nenhum item pedido.", False)
		
	End If
	
End Sub



'Example:
'Cursor1 = SQL1.ExecQuery("SELECT * FROM TableName WHERE Col1 = ? AND Col2 >= ? And Col2 <= ? ", Array As Object MyText, minVal, maxVal))

'SQL1.ExecNonQuery2("INSERT INTO table1 VALUES(?, ?, ?)", Array As Object("abc”,3, 4))

'#######################################################################################################
   	' SQL3 
	'
	'Tabela: Pizza   Campos	: id, sabor, detalhe, precop, preco, precog, stk
	'		 Refri			: id, sabor, detalhe, preco, OkMenu, Stk, StkMin, Obs  
	'		 Extras			: id, sabor, detalhe, preco, OkMenu, Stk, StkMin, Obs
	'Tabela: Pedidos  Campos: id, idnuvem, nome, cel, CodCli, Data, entregue, valor, pago, codformapgto, codformaentrega, 
	'		 pedidostr, origem, msg, Bxdo
	'
	'										            vieram via pedidostr		
	'									          |______________________________|	
	'Tabela: Logis    Campos: id, idbase, idnuvem, idpedcli, taborig, coditem, qtd, bxdo, codcli, codentregador
	'                            	|	             |
	'								|		         |>é o id da tempped do cliente, que veio no pedidostr
	'							    |
	'								|>é o id na Tab: Pedidos.id do SQL3
	




'Type Logis(id, idbase, idnuvem, idpedcli, taborig, coditem, qtd, bxdo, codcli, codentregador)
Sub DesMontaPedidostr(StrDaNuvem As String, bxdomin As Int, bxdomax As Int) 
	'Montar o Type Logis (volátil) com base no SQL3:Pedidos(+pedidostr)
	
	'1. Pescar as linhas pendentes (no processo = bxdo 
	
	
	
	
	
End Sub




Sub MontaPedidoStr() As String
	Dim Lista As List
	Dim linha() As String
	Lista.Initialize
	Dim SQLX As String
		
	' SQL2
		
	'Tabela: Pedidos    Campos: id, idnuvem, nome, cel, CodCli, Data, entregue, valor, pago, formapgto,
	'							codformaentrega, pedidostr, origem, msg, Bxdo
		
	' TempPed:  id, TabOrig, CodItem, sabor, detalhe, Qtd, Preco, Desconto, VlrTotItem,
	'			bxdoi, ordem, idpedidos

	SQLX="SELECT * FROM tempped WHERE idpedidos=" & Starter.idpedidos 

	Lista=DBUtils.ExecuteMemoryTable(Starter.SQL2,SQLX,Null,0) 'Lista dos itens pedidos
		
	If Lista.Size>0 Then
		Log("Qtd de itens no pedido = " & Lista.Size)

		Dim pedidostr_ As StringBuilder
		pedidostr_.Initialize
		
		For i=0 To Lista.Size-1
	
			' TempPed:  id, TabOrig, CodItem, sabor, detalhe, Qtd, Preco, Desconto, VlrTotItem,
			'			bxdoi, ordem, idpedidos
			
			linha=Lista.get(i)
				
			pedidostr_.Append(linha(0)).Append(";")   	' Id.......da linha do tempped, enquanto não apagar
			pedidostr_.Append(linha(1)).Append(";")		' TabOrig
			pedidostr_.Append(linha(2)).Append(";")		' CodItem
			pedidostr_.Append(linha(5)).Append(":")		' qtd     +    Append("  2 pontos! ")
						
		Next
		
		pedidostr_.Remove(pedidostr_.Length-1,pedidostr_.Length) 'Tira o último ":"
			
		Log("Pedidostr = " & pedidostr_.tostring)
		Return(pedidostr_.Tostring)
	Else
		Return("")
	End If
		
End Sub



Sub EnviaPedido

	If  DB.Connected=False Then
		ToastMessageShow("4-Sem conexão.",False)
	Else
		'##############################################################################################################
		'########################################  Envia p Nuvem  a linha do pedido na Tab:Pedidos  ###################
		'##############################################################################################################
		'			'----- Apaga jornadames com MesAno e IdColega -----------??????????????
		'
		'			INSERT INTO `laparma`.`pedidos` (`id`, `idnuvem`, `nome`, `cel`, `CodCli`, `Data`, `entregue`, `valor`, `pago`, `codformapgto`, `codformaentrega`, `pedidostr`, `origem`, `msg`, `Bxdo`) VALUES (NULL, NULL, 'Nome', 'Cel#', '1234', '01082017', '1', '45.00', '1', '1', '1', '123rtyyuyndfhndfhnmdghn', '1', 'Mensagem', '9');
		
	
					
		
		Dim SQLX As String
		If Main.TpPed.idnuvem=0 Then 'Não tem idnuvem na Nuvem
			
			'####################################################################################################
			
			Main.TpPed.id=DB.LastID("id", "pedidos")+1   'Prox. número para subst o idpedidos=0
			Starter.idpedidos=Main.TpPed.id
			Starter.ttmap.put("idpedidos", Starter.idpedidos)
			'----------------------------------------------------------------------------------------------------
			File.WriteMap(Starter.DirX,"TT.txt",Starter.ttmap)
			Starter.kvs.Put("tpped", Main.TpPed)
			'####################################################################################################

			SQLX= "INSERT INTO `laparma`.`pedidos` (`id`, `idnuvem`, `nome`, `cel`, `CodCli`, `Data`, `entregue`, `valor`, `pago`, `codformapgto`, `codformaentrega`, `pedidostr`, `origem`, `msg`, `Bxdo`) VALUES ("
			'(NULL, NULL, 'Nome', 'Cel#', '1234', '01082017', '1', '45.00', '1', '1', '1', '123rtyyuyndfhndfhnmdghn', '1', 'Mensagem', '9');
			SQLX=SQLX & Starter.idpedidos & ","
			SQLX=SQLX & "Null" & ",'"
			SQLX=SQLX & Starter.clinome & "','"
			SQLX=SQLX & Starter.clicel & "','"
			SQLX=SQLX & Starter.clicode & "','"
			SQLX=SQLX & Starter.DiaHora & "','"
			SQLX=SQLX & Starter.entregue & "','"
			SQLX=SQLX & Starter.TotalPed & "','"
			SQLX=SQLX & Starter.pago & "','"
			SQLX=SQLX & Starter.codformapgto & "','"
			SQLX=SQLX & Starter.codformaentrega & "','"
			SQLX=SQLX & Starter.pedidostr & "','"
			SQLX=SQLX & Starter.origem & "','"
			SQLX=SQLX & Starter.msg & "',"
			SQLX=SQLX & Starter.Bxdo & ");"
			Log("SQLX = " & SQLX)
			Executa_Query(SQLX, "AdicionaNaNuvem")
			
		Else 'Editar pedido com Starter.idnuvem=0<>0

			Dim DBder As StringBuilder
			DBder.initialize
			DBder.Append("UPDATE `laparma`.`pedidos` SET ")
			DBder.Append("`entregue` = ").Append("'").Append(Starter.entregue).Append("',")
			DBder.Append("`valor` = ").Append("'").Append(Starter.TotalPed).Append("',")
			DBder.Append("`pago` = ").Append("'").Append(1).Append("',")
			DBder.Append("`codformapgto` = ").Append("'").Append(Starter.codformapgto).Append("',")
			DBder.Append("`codformaentrega` = ").Append("'").Append(Starter.codformaentrega).Append("',")
			DBder.Append("`pedidostr` = ").Append("'").Append(Starter.pedidostr).Append("',")
			DBder.Append("`origem` = ").Append("'").Append(Starter.origem).Append("',")
			DBder.Append("`msg` = ").Append("'").Append(Starter.msg).Append("',")
			DBder.Append("`bxdo` = ").Append("'").Append(Starter.bxdo).Append("',")
			DBder.Append("WHERE ")
			DBder.Append("`pedidos`.`idnuvem` = ").Append("'").Append(Main.TpPed.idnuvem).Append("';")
			SQLX=DBder.ToString
			Executa_Query(SQLX, "AtualizadoNuvem")
		End If

	End If
	
End Sub

Sub BaixaPedidos
	Dim SQLX As String
	SQLX="SELECT * FROM pedidos WHERE bxdo=5"
	Executa_Query(SQLX, "BxPedidos")
End Sub

Sub Executa_Query(Query As String, JobName As String) 'No  Starter
	Dim job As HttpJob
	If  DB.Connected=False Then
		ToastMessageShow("12 - Sem conexão.",False)
		Log("Net não conectada")
		'=========================================   Guardar/Carregar do NoConn =============================================
		Select JobName
			Case "XXXXXXXXXX"
				'Aqui não tem o que  fazer. Pois idttnuvem já foi offlined em -1. Tenho q ficar tentando atualizar na nuvem
		End Select
	Else
		Log("Net Ok!, Executa_Query: " & Query & "      JobName:   " & JobName )
		job.Initialize(JobName, Me)
		job.PostString("http://digibob.online/laparma.php", Query)
	End If

End Sub

Sub JobDone(job As HttpJob)    'No  Starter
	ProgressDialogHide
	
	If job.Success Then
		Log("Job.GetString=" & job.GetString)
		Select job.JobName
			
			Case "AdicionaNaNuvem"
				Executa_Query("SELECT idnuvem FROM pedidos WHERE id=" & Starter.idpedidos ,"NovoCode")
				
			Case "NovoCode"
				Log("Job.GetString=" & job.GetString)
				Dim parser As JSONParser
				parser.Initialize(job.getstring)
				Dim root As List = parser.NextArray
				If root.Size>0 Then
					For Each colroot As Map In root
						Starter.idnuvem=colroot.Get("idnuvem")
						Exit
					Next
				End If
				Dim WhereFields As Map
				WhereFields.Initialize
				WhereFields.Put("id", Starter.idpedidos )
				DBUtils.UpdateRecord(Starter.SQL2, "pedidos" , "idnuvem", Starter.idnuvem, WhereFields)'
				Main.TpPed.idnuvem=Starter.idnuvem
				File.WriteMap(Starter.DirX,"TT.txt",Starter.ttmap)
				
				ToastMessageShow("13 - O Nr. do seu pedido é : " & Starter.idnuvem,True)
					
			Case "BxPedidos"
				Log("Job.GetString=" & job.GetString)
				Dim parser As JSONParser
				parser.Initialize(job.getstring)
				Dim root As List = parser.NextArray
				Dim ListOfMaps As List
				
				If root.Size>0 Then
					For Each colroot As Map In root
						ListOfMaps.Initialize
						ListOfMaps.Add(colroot)
						Log("ListOfMaps = " & ListOfMaps)
						DBUtils.InsertMaps(Starter.SQL3, "pedidos", ListOfMaps)
					Next
				End If
				
			Case "AtualizadoNuvem"
				ToastMessageShow("14 - O pedido : " & Starter.idnuvem & " foi editado.",True)
				
		End Select
		
	Else
		Log(job.ErrorMessage)
		ToastMessageShow("15 - Error: " & job.ErrorMessage, True)
	End If
	job.Release
End Sub


