﻿Type=StaticCode
Version=6.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Public  Agora, AgoraDT,HJ_000, HJ_800,HJ_1730, HJ_2359 As String
	Public  Tics000, Tics800, Tics1730, Tics2359, TicsAgora As Long
	Dim dateS As AHDateTime
	Type Period (Years As Int, Months As Int, Days As Int, Hours As Int, Minutes As Int, Seconds As Int)
	'Period(0,0,0,0,5,0)
	
	
End Sub
Sub Tempodisp(Tics As Long) As String
	Dim Resposta As String
	Dim dateS As AHDateTime
	dateS.Initialize
	dateS.Pattern= "dd/MM HH:mm"
	Resposta=dateS.Format(Tics)
	Return(Resposta)
End Sub
Sub AtoDisp1(Ato As String) As String
	Dim DuStr As StringBuilder
	DuStr.initialize
	
	'10620170730  p  01/06/2017  7:30
	
	'251020171236
	'  "25/0 2:36"
	'  " 5/5 2:6
	DuStr.Append(Ato.SubString2(0,2)).Append("/").Append(Ato.SubString2(2,4)).Append(" ").Append(Ato.SubString2(8,10)).Append(":").Append(Ato.SubString2(10,12))
	Return(DuStr)
End Sub

Sub AtoDisp(Ato As String) As String
Dim DuStr As StringBuilder
	DuStr.initialize
    If Ato.Length>0 Then
		'1;010620170730;XX  p  01/06 7:30
		'251020171236
		'  "25/0 2:36"
		'  " 5/5 2:6
		DuStr.Append(Ato.SubString2(2,4)).Append("/").Append(Ato.SubString2(4,6)).Append(" ").Append(Ato.SubString2(10,12)).Append(":").Append(Ato.SubString2(12,14))
	End If
	
	Return(DuStr)
End Sub

Sub VoltaTics(MMddyyyyHHmm As String) As Long
	Dim Tics As Long
	Dim dateS As AHDateTime
	dateS.Initialize
	dateS.Pattern= "MMddyyyyHHmm"
	
	Tics = dateS.Parse(MMddyyyyHHmm)
	Return(Tics)
End Sub

Sub VoltaTics1(ddMMyyyyHHmm As String) As Long
	'Vem co o formato acima e devolve os Tics
	Dim Tics As Long
	Dim dateS As AHDateTime
	dateS.Initialize
	dateS.Pattern= "ddMMyyyyHHmm"
	Try
		Tics = dateS.Parse(ddMMyyyyHHmm)
	Catch
		Log(LastException)
		Tics=0
	End Try
	
	Return(Tics)
End Sub

Sub VoltaTics2(yyyyMMddHHmm As String) As Long
	'Vem co o formato acima e devolve os Tics
	Dim Tics As Long
	Dim dateS As AHDateTime
	dateS.Initialize
	dateS.Pattern= "yyyyMMddHHmm"
	Tics = dateS.Parse(yyyyMMddHHmm)
	Return(Tics)
End Sub



Sub VoltaTicsAgora As Long
	Dim Tics As Long
	Dim Mins As Int=DateTime.GetMinute(DateTime.Now)
	Dim Minutos As String=Mins
	Dim DummyDate As String
	Dim dateS As AHDateTime
	dateS.Initialize
	dateS.Pattern= "yyyyMMddHHmm"
	DummyDate=Ano&Mes&Dia&Hora&Minutos
	Tics = dateS.Parse(DummyDate)
	Return(Tics)
End Sub
Sub VoltaTicsAgoraMais5() As Long
	Dim Tics As Long
	Dim Mins As Int=DateTime.GetMinute(DateTime.Now)+5
	Dim Minutos As String=Mins
	Dim DummyDate As String
	Dim dateS As AHDateTime
	dateS.Initialize
	dateS.Pattern= "yyyyMMddHHmm"
	
	
	'2017  07  14  09 48
	
	DummyDate=Ano&Mes&Dia&Hora&Minutos



	Tics = dateS.Parse(DummyDate)
	Return(Tics)
End Sub
Sub Minuto As String
	Dim Dumm As String
	Dumm = DateTime.GetMinute(DateTime.Now)
	Return(String.Right("0" & Dumm,2))
End Sub
Sub Hora As String
	Dim Dumm As String
	Dumm =DateTime.GetHour(DateTime.Now)
	Return(String.Right("0" & Dumm,2))
End Sub
Sub Dia As String
	Dim Dumm As String
	Dumm = DateTime.GetDayOfMonth(DateTime.Now)
	Return(String.Right("0" & Dumm,2))
End Sub
Sub Ontem As String
	Dim Dumm As String
	Dumm = (DateTime.GetDayOfMonth(DateTime.Now)-1)
	Return(String.Right("0" & Dumm,2))
End Sub
Sub Ano As String
	Dim Dumm As String
	Dumm = DateTime.GetYear(DateTime.Now)
	Return(String.Right("00" & Dumm,4))
End Sub
Sub Mes As String
	Dim Dumm As String
	Dumm = DateTime.GetMonth(DateTime.Now)
	Return(String.Right("0" & Dumm,2))
End Sub
Sub MesAno As String
	Dim Dumm As String
	Dim Dumm1 As String
	Dumm = DateTime.GetMonth(DateTime.Now)
	Dumm1 =  DateTime.GetYear(DateTime.Now)
	Return(String.Right("0" & Dumm,2) & String.Right(Dumm1,2) )
End Sub
Sub MesAnt As String
	Dim Dumm As String
	Dumm = (DateTime.GetMonth(DateTime.Now)-1)
	Return(String.Right("0" & Dumm,2))
End Sub
Sub HJ2359 As String
	HJ_2359 = Mes & "/" & Dia & "/" & Ano & " 23:59"
	Return(HJ_2359)
End Sub
Sub TicsHJ2359 As Long
	dateS.Initialize
	dateS.Pattern= "MM/dd/yyyy HH:mm"
	
	Log("dateS.Pattern=" & dateS.Pattern)
	
	Tics2359 = dateS.parse(HJ2359)
	Return(Tics2359)
End Sub
Sub TicsHJ000 As Long
	dateS.Initialize
	dateS.Pattern= "MM/dd/yyyy HH:mm"
	Tics000 = dateS.parse(HJ000)
	Return(Tics000)
End Sub
Sub TicsHJ800 As Long
	dateS.Initialize
	dateS.Pattern= "MM/dd/yyyy HH:mm"
	'Tics800 = dateS.parse(HJ800)
	Return(Tics800)
End Sub
Sub TicsHJ1730 As Long
	dateS.Initialize
	dateS.Pattern= "MM/dd/yyyy HH:mm"
	'Tics1730 = dateS.parse(HJ1730)
	Return(Tics800)
End Sub
Sub HJ000 As String
	HJ_000 = Mes & "/" & Dia & "/" & Ano & " 00:00"
	Return(HJ_000)
End Sub
'
'Sub HJ800 As String
'	HJ_800 = Dia & "/" & Mes & "/" & Ano & " 08:00"
'	Return(HJ_800)
'End Sub

'Sub HJ1730 As String
'	HJ_1730 = Dia & "/" & Mes & "/" & Ano & " 17:30"
'	Return(HJ_1730)
'End Sub



'
'   H     	= Tics da Hora Mostrada na entrada,
'Titulo 	= Header da janelinha,
' Tipo  	= 1 só Horario, Tipo=2 só Data e Tipo=3 ambos....0 = now (dia e hora)..Sem perguntar
'TicsMin    = Não aceita entrada antes desta DataHora
'TicsMax	= Não aceita entrada após esta DataHora
'
' Obs.: P/ H usar VoltaTics1, Voltatics2 ou Voltatics3 
'           conforme formato da data.
'Retorna: 
'	Resp(1)	= 011220171415
'	Resp(2)   = 01/12/2017 14:15
'	Resp(3)   = 01/12 14:15
'	Resp(4)	= 201712011415
'	Resp(5)   = 20171201
'	Resp(6)   = 201712
'	Resp(7)   = (Tics)			
'	Resp("ret") 'Volta com o ret para saber se caiu fora com return.........
Sub HoraEdit(H  As Long, Titulo As String, Tipo As Int, TicsMin As Long, TicsMax As Long) As Map
	' Titulo="Inicio Trabalho", "Inicio Viagem"
	' H=VoltaTics1(ddMMyyyyHHmm As String) As Long
	
	'Tipo=0 entra data e hora de agora e nem pergunta,  =1 so Horario, =2 só Data, =3 ambos 
	
	Dim ret As Object
  	Dim Tics As Long
	
	Dim Dd As DateDialog
	Dim Td As TimeDialog
	
	Dim Resp As Map
	Dim RespDd As Map
	Dim RespTd As Map
	
	Resp.initialize
	RespDd.initialize
	RespTd.initialize
	
	Dim PrimaVez As Boolean = True


	
		Do While  PrimaVez
			PrimaVez=False
			RespDd = BuscaData(H,Titulo,Tipo)   '.......Busca o Dia
			Dd=RespDd.Get("dd")
			If RespDd.Get("ret")=-3 Then
				ret=-3
			   Exit
			End If
			
			RespTd = BuscaHora(H,Titulo,Tipo)	'.......Busca a Hora
			Td=RespTd.Get("td")
			If RespTd.Get("ret")=-3 Then
				'Cai Fora
				ret=-3
				Exit
			End If

			'===========================================   Monta Tics da Entrada  ===================================
			Dim dateS As AHDateTime
			dateS.Initialize
			dateS.Pattern= "dd/MM/yyyy HH:mm"
			Dim DummyDate5 As String
			DummyDate5=Dd.DayOfMonth & "/" & Dd.Month & "/" & Dd.Year & " " & Td.Hour & ":" & Td.Minute
			Tics = dateS.Parse(DummyDate5)
		'=====================================================================================================
		
		
		If TicsMin>0 Or TicsMax>0 Then 'Se tem valor...deve testar......
			
			If Tics<TicsMin Then
				'================================================ DataHora entrada esta antes da última Entrada ==================
				Dim IDI As InputDialog
				IDI.InputType = IDI.INPUT_TYPE_NONE
				'IDI.Input = ""
				IDI.Hint = "Data Min. => " & Tempodisp(TicsMin)
							IDI.HintColor = Colors.ARGB(196, 255, 140, 0)
				ret = DialogResponse.CANCEL
				ret = IDI.Show(  "Entra HoraData","Erro de entrada.", "Entra de novo.","Cancela","Vai assim.", Null)
				Log("ret=" & ret)

				If ret=-1 Then '.............."Entra de novo."
					PrimaVez=True
				Else if ret="-2" Then '.......... "Vai assim."
					PrimaVez=False
				Else if ret=-3 Then
					PrimaVez=False
				End If
				
			else IF Tics>TicsMax Then
				'================================================ DataHora entrada esta antes da última Entrada ==================
				Dim IDI As InputDialog
				IDI.InputType = IDI.INPUT_TYPE_NONE
				'IDI.Input = ""
				IDI.Hint = "Data Max. => " &  Tempodisp(TicsMax)
				IDI.HintColor = Colors.ARGB(196, 255, 140, 0)
				ret = DialogResponse.CANCEL
				ret = IDI.Show( "","Erro de entrada.", "Entra de novo.","Cancela","Vai assim.", Null)
				Log("ret=" & ret)

				If ret=-1 Then '.............."Entra de novo."
					PrimaVez=True
				Else if ret="-2" Then '.......... "Vai assim."
					PrimaVez=False
				Else if ret=-3 Then
					PrimaVez=False
				End If
				
			End If
			
		Else
			Exit
		End If
		
		Loop
	
	If Tipo=0 Then
	 	Dim DiaStr As String = Dia
		Dim MesStr As String = Mes
		Dim AnoStr As String =  Ano
		Dim HoraStr As String= Hora
		Dim MinStr As String =  Minuto
 	Else
		Dim DiaStr As String = String.Right("0" & Dd.DayOfMonth,2)
		Dim MesStr As String = String.Right("0" & Dd.Month,2)
		Dim AnoStr As String=  String.Right("00"& Dd.year,4)
		Dim HoraStr As String= String.Right("0" & Td.Hour,2)
		Dim MinStr As String= String.Right("0" & Td.Minute,2)	
	End If
	
		Resp.put(1,DiaStr&MesStr&AnoStr&HoraStr&MinStr) 									'011220171415
		Resp.Put(2,DiaStr & "/" & MesStr & "/" & AnoStr & " " & HoraStr & ":" & MinStr)		'01/12/2017 14:15
		Resp.Put(3,DiaStr & "/" & MesStr & " " & HoraStr & ":" & MinStr)					'01/12 14:15
		Resp.Put(4,AnoStr&MesStr&DiaStr&HoraStr&MinStr)										'201712011415
		Resp.Put(5,AnoStr & MesStr & DiaStr)												'20171201
		Resp.Put(6,AnoStr&MesStr)															'201712
		Resp.Put(7,Tics)																	'10239000000000						
		Resp.Put("ret",ret) 'Volta com o ret para saber se caiu fora com return.........
		Return(Resp)
	
End Sub







'   H     	= Tics da Hora Mostrada na entrada,
'Titulo 	= Header da janelinha,
' Tipo  	= 1 só Horario, Tipo=2 só Data e Tipo=3 ambos)
Sub BuscaHora(H  As Long, Titulo As String, Tipo As Int)  As Map
	Dim Resp As Map
	Resp.initialize
	Dim ret As Int
	Dim td As TimeDialog
	td.Hour = DateTime.GetHour(H)
	td.Minute = DateTime.GetMinute(H)
	td.Is24Hours = True
	
	If Tipo=1 Or Tipo=3 Then '================================================  ou só horário ou ambos
		ret = td.Show("", Titulo, "Continua", "", "", Null)
		'ToastMessageShow("ret= " & ret & "Horas=> "  & td.hour & ":" & td.minute , False)
	End If
	Resp.Put("ret",ret)
	Resp.Put("td", td)
	Return(Resp)
End Sub



'   H     	= Tics da Hora Mostrada na entrada,
'Titulo 	= Header da janelinha,
' Tipo  	= 1 só Horario, Tipo=2 só Data e Tipo=3 ambos)
Sub BuscaData(H  As Long, Titulo As String, Tipo As Int) As Map
	Dim ret As Int
	Dim Resp As Map
	Resp.initialize
	
	'=====================================================================
	Dim Dd As DateDialog
	'Dd.ShowCalendar = False
	Dd.Year = DateTime.GetYear(H)
	Dd.Month = DateTime.GetMonth(H)
	Dd.DayOfMonth = DateTime.GetDayOfMonth(H)
	
	If Tipo=2 Or Tipo=3 Then '================================================  ou só data ou ambos
		ret = Dd.Show("Data", Titulo, "Continua", "", "", Null)
		'ToastMessageShow(ret & " : " & Dd.DayOfMonth & "/" & Dd.Month & "/" & Dd.Year , False)
	End If
	Resp.put("dd", Dd)
	Resp.Put("ret",ret)
	Return(Resp)
	'===========================================  Fim entrada Data ==========================================
End Sub













